/*
 * Clases para manejar temporizadores
 */

#ifndef _SDL_TIMER
#define _SDL_TIMER
#include <SDL.h>

namespace sdl {

class Timer {
protected:
    SDL_TimerCallback CallBack;
    SDL_TimerID id;
    Uint32 interval;
    void *param;

public:
    Timer() : CallBack(0), id(0), interval(0), param(NULL) {}
    Timer(Uint32 i, void *p) : interval(i), param(p) {}
    ~Timer() {
        if(id!=0) SDL_RemoveTimer(id);
    }
    void SetCallback(SDL_TimerCallback callback) {
        CallBack = callback;
    }
    Uint32 SetInterval(Uint32 i) {
        Uint32 retval = interval;
        interval = i;
        return retval;
    }
    void* SetParam(void *p) {
        void* retval = param;
        param = p;
        return retval;
    }
    SDL_TimerID Init() {
        id = SDL_AddTimer(interval, CallBack, param);
        return id;
    }
    SDL_TimerID Id() const { return id; }
};

} // namespace

#endif // _SDL_TIMER
